import { PluginOptions, AuthAccessCallback, AuthCallback, PackageAccess, IPluginAuth, RemoteUser, Logger, Config } from '@verdaccio/types';
/**
 * Custom Verdaccio Authenticate Plugin.
 */
export default class AclPlugin implements IPluginAuth<Config> {
    logger: Logger;
    private userGroups;
    private static ACCESS_ACTION;
    private static PUBLISH_ACTION;
    private static UNPUBLISH_ACTION;
    constructor(config: Config, options: PluginOptions<Config>);
    private allowAction;
    /**
     * Authenticate an user.
     * @param user user to log
     * @param password provided password
     * @param cb callback function
     */
    authenticate(user: string, password: string, cb: AuthCallback): void;
    /**
     * Triggered on each access request
     * @param user
     * @param pkg
     * @param cb
     */
    allow_access(user: RemoteUser, pkg: PackageAccess, cb: AuthAccessCallback): void;
    /**
     * Triggered on each publish request
     * @param user
     * @param pkg
     * @param cb
     */
    allow_publish(user: RemoteUser, pkg: PackageAccess, cb: AuthAccessCallback): void;
    allow_unpublish(user: RemoteUser, pkg: PackageAccess, cb: AuthAccessCallback): void;
    private splitString;
}
